using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.UI;

public class RankingList : MonoBehaviour
{
	[SerializeField]
	[Tooltip("LOf[^1̃IuWFNgf[^")]
	GameObject rankingObject;

	[SerializeField]
	[Tooltip("LOf[^te")]
	RectTransform rootTransform;

	[SerializeField]
	[Tooltip("cтɂ邽߂̃R|[lg")]
	LayoutGroup verticalLayoutGroup;

	[SerializeField]
	[Tooltip("fobO͗p")]
	InputField inputField;

	[SerializeField]
	Button save;

	[SerializeField]
	Button reset;

	string RankingDataPath { get { return $"{Application.persistentDataPath}/ranking"; } }

	/// <summary>LOf[^\</summary>
	int rankingDataCount = 5;

	RankingObject[] rankingObjects;

	private void Start()
	{
		if (rankingObject == null) 
		{
			Debug.LogError("LOIuWFNgݒ肳ĂȂII");
			return;
		}

		CreateObject();

		if (inputField != null)
		{
			inputField.onEndEdit.AddListener((str) =>
			{
				try
				{
					var f = float.Parse(str);
					AddRanking(f);
				}
				catch (Exception ex)
				{
					Debug.LogWarning("ȂII");
				}
			});
		}

		if (save != null) { save.onClick.AddListener(() => { Save(); }); }
		if (reset != null) { reset.onClick.AddListener(() => { ResetRanking(); }); }
	}

	void CreateObject()
	{
		{
			var r = rankingObject.AddComponent<RankingObject>();
			rankingObject.SetActive(false);
		}

		//LO\pf[^̍쐬
		rankingObjects = new RankingObject[rankingDataCount];
		for (int i = 0; i < rankingDataCount; i++)
		{
			var go = Instantiate(rankingObject);
			var item = go.GetComponent<RankingObject>();
			item.Ranking = i + 1;
			go.transform.SetParent(rootTransform, false);
			go.SetActive(true);

			rankingObjects[i] = item;
		}

		//쐬LOIuWFNg̃CAEgXV
		IEnumerator delayUpdateProcess()
		{
			yield return null;
			verticalLayoutGroup.CalculateLayoutInputHorizontal();
			verticalLayoutGroup.CalculateLayoutInputVertical();
			verticalLayoutGroup.SetLayoutVertical();
			verticalLayoutGroup.SetLayoutHorizontal();
		}
		StartCoroutine(delayUpdateProcess());

		Load();
	}

	void UpdateRankingList(float[] list)
	{
		for (int i = 0; i < rankingDataCount; i++) 
		{
			rankingObjects[i].Time = list[i];
		}
	}

	/// <summary>
	/// LOǉ
	/// </summary>
	/// <param name="time">L^</param>
	public void AddRanking(float time)
	{
		var list = new List<float>();
		for (int i = 0; i < rankingDataCount; i++)
		{
			list.Add(rankingObjects[i].Time);
		}

		for (int i = 0; i < rankingDataCount; i++) 
		{
			if (list[i] > time) 
			{
				var last = list[rankingDataCount - 1];
				last = time;
				list.RemoveAt(rankingDataCount - 1);
				list.Insert(i, last);
				UpdateRankingList(list.ToArray());
				break;
			}
		}
	}

	/// <summary>
	/// LOf[^ǂݍ
	/// </summary>
	public void Load()
	{
		if (!File.Exists(RankingDataPath)) { return; }
		var text = File.ReadAllText(RankingDataPath);
		var dataList = text.Replace("\r\n", "\n").Replace("\r", "\n").Split('\n');

		for (int i = 0; i < rankingDataCount && i < dataList.Length; i++) 
		{
			var time = dataList[i];
			if(time.Length <= 0)
			{
				//ϊsȃf[^܂܂Ă̂ŏI
				break;
			}
			rankingObjects[i].Time = float.Parse(time);
		}
	}

	/// <summary>
	/// LOf[^ۑ
	/// </summary>
	public void Save()
	{
		string data = "";
		for (int i = 0; i < rankingDataCount; i++) 
		{
			data += rankingObjects[i].Time + ((i + 1) < rankingDataCount ? "\n" : "");
		}
		File.WriteAllText(RankingDataPath, data);
	}

	/// <summary>
	/// LOf[^폜
	/// </summary>
	public void ResetRanking()
	{
		File.Delete(RankingDataPath);
	}

}
