using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;


public class RankingObject : MonoBehaviour
{
	[SerializeField]
	Text ranking;

	[SerializeField]
	Text time;

	public int Ranking 
	{
		get 
		{
			int result = -1;
			int.TryParse(ranking.text, out result);
			return result;
		}
		set { ranking.text = value.ToString();}
	}

	public float Time
	{
		get { return StringToTime(time.text); }
		set { time.text = TimeToString(value); }
	}

	public float StringToTime(string timeString)
	{
		int m = 0;
		float s = 0;

		int.TryParse(time.text.Split(':')[0], out m);
		float.TryParse(time.text.Split(':')[1], out s);

		return m * 60 + s;
	}

	string TimeToString(float time)
	{
		int m = (int)time / 60;
		double s = time - m * 60;
		return $"{m}:{s.ToString("F3")}";
	}

	private void Start()
	{
	}
}
